/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.50 Revision 1.159
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.50 2009/11/09 19:35:44 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.159 2015/03/06 14:08:07 dlan Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16 16
17IUSE="${IUSE} debug pch" 17inherit eutils flag-o-matic multilib toolchain-funcs
18RDEPEND=" 18
19 !<x11-libs/qt-assistant-${PV} 19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20 !>x11-libs/qt-assistant-${PV}-r9999 20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21 !<x11-libs/qt-core-${PV} 21SLOT="4"
22 !>x11-libs/qt-core-${PV}-r9999 22
23 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999
25 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV}
36 !>x11-libs/qt-script-${PV}-r9999
37 !<x11-libs/qt-sql-${PV}
38 !>x11-libs/qt-sql-${PV}-r9999
39 !<x11-libs/qt-svg-${PV}
40 !>x11-libs/qt-svg-${PV}-r9999
41 !<x11-libs/qt-test-${PV}
42 !>x11-libs/qt-test-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47"
48case "${PV}" in 23case ${PV} in
49 4.?.?_rc* | 4.?.?_beta* ) 24 4.?.9999)
50 SRCTYPE="${SRCTYPE:-opensource-src}" 25 QT4_BUILD_TYPE="live"
51 MY_PV="${PV/_/-}" 26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
52 ;; 32 ;;
53 *) 33 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}" 34 QT4_BUILD_TYPE="release"
55 MY_PV="${PV}" 35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
56 ;; 38 ;;
57esac 39esac
58 40
59if version_is_at_least 4.5.99999999 ${PV} ; then 41IUSE="aqua debug pch"
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}" 42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
61else 43
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}" 44DEPEND="virtual/pkgconfig"
45if [[ ${QT4_BUILD_TYPE} == live ]]; then
46 DEPEND+=" dev-lang/perl"
63fi 47fi
64S=${WORKDIR}/${MY_P}
65
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81 48
82# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 50# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 51# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 53 # Warn users of possible breakage when downgrading to a previous release.
87 if [[ $EAPI != 2 ]]; then 54 # Downgrading revisions within the same release is safe.
88 # Make sure debug setting corresponds with qt-core (bug 258512) 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
89 if [[ $PN != "qt-core" ]]; then 56 ewarn
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
91 ~x11-libs/qt-core-${PV} debug" 58 ewarn
92 fi 59 fi
93 60
94 # Check USE requirements
95 qt4-build_check_use
96 fi
97
98 PATH="${S}/bin:${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
62 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
100 64 else
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 65 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 66 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
103 echo 67 # platform detection. Note: needs to come before any directories to
104 ebeep 3 68 # avoid extract failure.
69 [[ ${CHOST} == *-apple-darwin* ]] && \
70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
71 ${QT4_EXTRACT_DIRECTORIES}"
105 fi 72 fi
106} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
107 95
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
109# @DESCRIPTION: 98# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 99# Space-separated list of directories that will be configured,
111# code should be compiled. This is a space-separated list 100# compiled, and installed. All paths must be relative to ${S}.
112
113# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
114# @DESCRIPTION:
115# Space separated list including the directories that will be extracted from Qt
116# tarball
117 101
118# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 103# @DESCRIPTION:
120# Unpacks the sources 104# Unpacks the sources.
121qt4-build_src_unpack() { 105qt4-build_src_unpack() {
122 setqtenv 106 setqtenv
123 local target targets licenses tar_pkg tar_args 107
124 if version_is_at_least 4.5 ${PV} ; then 108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
125 licenses="LICENSE.GPL3 LICENSE.LGPL" 109 ewarn
126 else 110 ewarn "Using a GCC version lower than 4.4 is not supported."
127 licenses="LICENSE.GPL2 LICENSE.GPL3" 111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
128 fi 123 fi
129 for target in configure ${licenses} projects.pro \ 124 eshopts_pop
125 fi
126
127 case ${QT4_BUILD_TYPE} in
128 live)
129 git-r3_src_unpack
130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
131 ${QT4_EXTRACT_DIRECTORIES}; do 135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
132 targets="${targets} ${MY_P}/${target}" 137 targets+="${MY_P}/${target} "
133 done 138 done
134 139
135 tar_pkg=${MY_P}.tar.bz2 140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
136 tar_args="xjpf" 141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
137 if version_is_at_least 4.5.3 ${PV} ; then 142 eend $? || die "failed to unpack"
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
149 ;; 143 ;;
150 esac 144 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 145}
157
158# @ECLASS-VARIABLE: PATCHES
159# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure
161# to specify the full path. This variable is necessary for src_prepare phase.
162# example:
163# PATCHES="${FILESDIR}"/mypatch.patch
164# ${FILESDIR}"/mypatch2.patch"
165#
166 146
167# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION: 148# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
171qt4-build_src_prepare() { 151qt4-build_src_prepare() {
172 setqtenv 152 setqtenv
173 cd "${S}"
174 153
154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
155 QTDIR="." ./bin/syncqt || die "syncqt failed"
156 fi
157
158 # avoid X11 dependency in non-gui packages
159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
161
162 if use aqua; then
163 # provide a proper macx-g++-64
164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
165
166 sed -e '/^CONFIG/s:app_bundle::' \
167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
169 fi
170
175 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
176 skip_qmake_build_patch 172 skip_qmake_build
177 skip_project_generation_patch 173 skip_project_generation
178 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
179 fi 175 fi
180 176
181 # Bug 282984 177 if use_if_iuse c++0x; then
182 sed -e "s/\(^SYSTEM_VARIABLES\)/CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1/" \ 178 append-cxxflags -std=c++0x
183 -i configure || die "sed qmake compilers failed"
184 sed -e "s/\(\$MAKE\)/\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX)/" \
185 -i config.tests/unix/compile.test || die "sed test compilers failed"
186
187 # Bug 178652
188 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
189 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
190 append-flags -fno-gcse
191 fi
192
193 # Unsupported old gcc versions - hardened needs this :(
194 if [[ $(gcc-major-version) -lt "4" ]] ; then
195 ewarn "Appending -fno-stack-protector to CXXFLAGS"
196 append-cxxflags -fno-stack-protector
197 # Bug 253127
198 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
199 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
200 fi 179 fi
201 180
202 # Bug 261632 181 # Bug 261632
203 if use ppc64; then 182 if use ppc64; then
204 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
205 append-flags -mminimal-toc 183 append-flags -mminimal-toc
206 fi 184 fi
207 185
186 # Bug 373061
187 # qmake bus errors with -O2 or -O3 but -O1 works
188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 replace-flags -O[23] -O1
190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
196 fi
197
198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
199 sed -e "/^SYSTEM_VARIABLES=/i \
200 CC='$(tc-getCC)'\n\
201 CXX='$(tc-getCXX)'\n\
202 CFLAGS='${CFLAGS}'\n\
203 CXXFLAGS='${CXXFLAGS}'\n\
204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
211 -i configure \
212 || die "sed SYSTEM_VARIABLES failed"
213
214 # Respect CC, CXX, LINK and *FLAGS in config.tests
215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
219 || die "sed config.tests failed"
220
208 # Bug 172219 221 # Bug 172219
222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223
224 if [[ ${CHOST} == *-darwin* ]]; then
225 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
226 # crippled (by design) :/
227 local mac_gpp_conf=
228 if [[ -f mkspecs/common/mac-g++.conf ]]; then
229 # qt < 4.8 has mac-g++.conf
230 mac_gpp_conf="mkspecs/common/mac-g++.conf"
231 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
232 # qt >= 4.8 has g++-macx.conf
233 mac_gpp_conf="mkspecs/common/g++-macx.conf"
234 else
235 die "no known conf file for mac found"
236 fi
237 sed \
209 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 238 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
210 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
211 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
212 -e "s:X11R6/::" \ 241 -e "s:-arch\s\w*::g" \
213 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 242 -i ${mac_gpp_conf} \
243 || die "sed ${mac_gpp_conf} failed"
214 244
215 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 245 # Fix configure's -arch settings that appear in qmake/Makefile and also
216 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 246 # fix arch handling (automagically duplicates our -arch arg and breaks
217 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 247 # pch). Additionally disable Xarch support.
218 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 248 local mac_gcc_confs="${mac_gpp_conf}"
249 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
250 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
251 fi
252 sed \
253 -e "s:-arch i386::" \
254 -e "s:-arch ppc::" \
255 -e "s:-arch x86_64::" \
256 -e "s:-arch ppc64::" \
257 -e "s:-arch \$i::" \
258 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
259 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
260 -e "s:-Xarch_x86_64::g" \
261 -e "s:-Xarch_ppc64::g" \
262 -i configure ${mac_gcc_confs} \
263 || die "sed -arch/-Xarch failed"
219 264
220 base_src_prepare 265 # On Snow Leopard don't fall back to 10.5 deployment target.
266 if [[ ${CHOST} == *-apple-darwin10 ]]; then
267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
269 -i configure ${mac_gpp_conf} \
270 || die "sed deployment target failed"
271 fi
272 fi
273
274 # this one is needed for all systems with a separate -liconv, apart from
275 # Darwin, for which the sources already cater for -liconv
276 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
277 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
278 -i config.tests/unix/iconv/iconv.pro \
279 || die "sed iconv.pro failed"
280 fi
281
282 # we need some patches for Solaris
283 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
285 # use GCC over SunStudio
286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
287 # do not flirt with non-Prefix stuff, we're quite possessive
288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
290
291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
221} 294}
222 295
223# @FUNCTION: qt4-build_src_configure 296# @FUNCTION: qt4-build_src_configure
224# @DESCRIPTION: 297# @DESCRIPTION:
225# Default configure phase 298# Default configure phase
226qt4-build_src_configure() { 299qt4-build_src_configure() {
227 setqtenv 300 setqtenv
228 myconf="$(standard_configure_options) ${myconf}"
229 301
302 local conf="
303 -prefix ${QTPREFIXDIR}
304 -bindir ${QTBINDIR}
305 -libdir ${QTLIBDIR}
306 -docdir ${QTDOCDIR}
307 -headerdir ${QTHEADERDIR}
308 -plugindir ${QTPLUGINDIR}
309 -importdir ${QTIMPORTDIR}
310 -datadir ${QTDATADIR}
311 -translationdir ${QTTRANSDIR}
312 -sysconfdir ${QTSYSCONFDIR}
313 -examplesdir ${QTEXAMPLESDIR}
314 -demosdir ${QTDEMOSDIR}
315 -opensource -confirm-license
316 -shared -fast -largefile -stl -verbose
317 -nomake examples -nomake demos"
318
319 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
320 # $(tc-arch). Therefore we convert it to supported values.
321 case "$(tc-arch)" in
322 amd64|x64-*) conf+=" -arch x86_64" ;;
323 ppc-macos) conf+=" -arch ppc" ;;
324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
326 x86-macos) conf+=" -arch x86" ;;
327 x86|x86-*) conf+=" -arch i386" ;;
328 alpha|arm|arm64|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
329 hppa|sh) conf+=" -arch generic" ;;
330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
331 esac
332
333 conf+=" -platform $(qt_mkspecs_dir)"
334
335 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
336
337 # debug/release
338 if use debug; then
339 conf+=" -debug"
340 else
341 conf+=" -release"
342 fi
343 conf+=" -no-separate-debug-info"
344
345 # exceptions USE flag
346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
347
348 # disable rpath (bug 380415), except on prefix (bug 417169)
349 use prefix || conf+=" -no-rpath"
350
351 # precompiled headers don't work on hardened, where the flag is masked
352 conf+=" $(qt_use pch)"
353
354 # -reduce-relocations
355 # This flag seems to introduce major breakage to applications,
356 # mostly to be seen as a core dump with the message "QPixmap: Must
357 # construct a QApplication before a QPaintDevice" on Solaris.
358 # -- Daniel Vergien
359 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
360
361 # this one is needed for all systems with a separate -liconv, apart from
362 # Darwin, for which the sources already cater for -liconv
363 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
364 conf+=" -liconv"
365 fi
366
367 if use_if_iuse glib; then
368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
369 # avoid the -pthread argument
370 conf+=" ${glibflags//-pthread}"
371 unset glibflags
372 fi
373
374 if use aqua; then
375 # On (snow) leopard use the new (frameworked) cocoa code.
376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
377 conf+=" -cocoa -framework"
378 # We need the source's headers, not the installed ones.
379 conf+=" -I${S}/include"
380 # Add hint for the framework location.
381 conf+=" -F${QTLIBDIR}"
382
383 # We are crazy and build cocoa + qt3support :-)
384 if use qt3support; then
385 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
386 -i configure || die
387 fi
388 else
389 conf+=" -no-framework"
390 fi
391 else
392 # freetype2 include dir is non-standard, thus pass it to configure
393 conf+=" $(pkg-config --cflags-only-I freetype2)"
394 fi
395
396 conf+=" ${myconf}"
397 myconf=
398
230 echo ./configure ${myconf} 399 echo ./configure ${conf}
231 ./configure ${myconf} || die "./configure failed" 400 ./configure ${conf} || die "./configure failed"
232 myconf="" 401
402 prepare_directories ${QT4_TARGET_DIRECTORIES}
233} 403}
234 404
235# @FUNCTION: qt4-build_src_compile 405# @FUNCTION: qt4-build_src_compile
406# @DESCRIPTION:
236# @DESCRIPTION: Actual compile phase 407# Actual compile phase
237qt4-build_src_compile() { 408qt4-build_src_compile() {
238 setqtenv 409 setqtenv
239 # Be backwards compatible for now
240 if [[ $EAPI != 2 ]]; then
241 qt4-build_src_configure
242 fi
243 410
244 build_directories "${QT4_TARGET_DIRECTORIES}" 411 build_directories ${QT4_TARGET_DIRECTORIES}
412}
413
414# @FUNCTION: qt4-build_src_test
415# @DESCRIPTION:
416# Runs tests only in target directories.
417qt4-build_src_test() {
418 # QtMultimedia does not have any test suite (bug #332299)
419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
420
421 for dir in ${QT4_TARGET_DIRECTORIES}; do
422 emake -j1 check -C ${dir}
423 done
424}
425
426# @FUNCTION: fix_includes
427# @DESCRIPTION:
428# For MacOS X we need to add some symlinks when frameworks are
429# being used, to avoid complications with some more or less stupid packages.
430fix_includes() {
431 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
432 local frw dest f h rdir
433 # Some packages tend to include <Qt/...>
434 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
435
436 # Fake normal headers when frameworks are installed... eases life later
437 # on, make sure we use relative links though, as some ebuilds assume
438 # these dirs exist in src_install to add additional files
439 f=${QTHEADERDIR}
440 h=${QTLIBDIR}
441 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
442 f=${f#*/}
443 h=${h#*/}
444 done
445 rdir=${h}
446 f="../"
447 while [[ ${h} == */* ]] ; do
448 f="${f}../"
449 h=${h#*/}
450 done
451 rdir="${f}${rdir}"
452
453 for frw in "${D}${QTLIBDIR}"/*.framework; do
454 [[ -e "${frw}"/Headers ]] || continue
455 f=$(basename ${frw})
456 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
457 dosym "${rdir}"/${f}/Headers "${dest}"
458
459 # Link normal headers as well.
460 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
461 h=$(basename ${hdr})
462 dosym "../${rdir}"/${f}/Headers/${h} \
463 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
464 done
465 done
466 fi
245} 467}
246 468
247# @FUNCTION: qt4-build_src_install 469# @FUNCTION: qt4-build_src_install
248# @DESCRIPTION: 470# @DESCRIPTION:
249# Perform the actual installation including some library fixes. 471# Perform the actual installation including some library fixes.
250qt4-build_src_install() { 472qt4-build_src_install() {
251 setqtenv 473 setqtenv
474
252 install_directories "${QT4_TARGET_DIRECTORIES}" 475 install_directories ${QT4_TARGET_DIRECTORIES}
253 install_qconfigs 476 install_qconfigs
254 fix_library_files 477 fix_library_files
478 fix_includes
479
480 # remove .la files since we are building only shared libraries
481 prune_libtool_files
255} 482}
256 483
257# @FUNCTION: setqtenv 484# @FUNCTION: setqtenv
485# @INTERNAL
258setqtenv() { 486setqtenv() {
259 # Set up installation directories 487 # Set up installation directories
260 QTBASEDIR=/usr/$(get_libdir)/qt4
261 QTPREFIXDIR=/usr 488 QTPREFIXDIR=${EPREFIX}/usr
262 QTBINDIR=/usr/bin 489 QTBINDIR=${QTPREFIXDIR}/bin
263 QTLIBDIR=/usr/$(get_libdir)/qt4 490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
264 QMAKE_LIBDIR_QT=${QTLIBDIR}
265 QTPCDIR=/usr/$(get_libdir)/pkgconfig 491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
266 QTDATADIR=/usr/share/qt4
267 QTDOCDIR=/usr/share/doc/qt-${PV} 492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
268 QTHEADERDIR=/usr/include/qt4 493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
269 QTPLUGINDIR=${QTLIBDIR}/plugins 494 QTPLUGINDIR=${QTLIBDIR}/plugins
270 QTSYSCONFDIR=/etc/qt4 495 QTIMPORTDIR=${QTLIBDIR}/imports
496 QTDATADIR=${QTPREFIXDIR}/share/qt4
271 QTTRANSDIR=${QTDATADIR}/translations 497 QTTRANSDIR=${QTDATADIR}/translations
498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
272 QTEXAMPLESDIR=${QTDATADIR}/examples 499 QTEXAMPLESDIR=${QTDATADIR}/examples
273 QTDEMOSDIR=${QTDATADIR}/demos 500 QTDEMOSDIR=${QTDATADIR}/demos
274 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 501 QMAKE_LIBDIR_QT=${QTLIBDIR}
502
275 PLATFORM=$(qt_mkspecs_dir) 503 PLATFORM=$(qt_mkspecs_dir)
276
277 unset QMAKESPEC 504 unset QMAKESPEC
278}
279 505
280# @FUNCTION: standard_configure_options 506 export XDG_CONFIG_HOME="${T}"
281# @DESCRIPTION: 507}
282# Sets up some standard configure options, like libdir (if necessary), whether
283# debug info is wanted or not.
284standard_configure_options() {
285 local myconf=""
286 508
287 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 509# @FUNCTION: prepare_directories
288 510# @USAGE: < directories >
289 # Disable visibility explicitly if gcc version isn't 4 511# @INTERNAL
290 if [[ "$(gcc-major-version)" -lt "4" ]]; then 512# @DESCRIPTION:
291 myconf="${myconf} -no-reduce-exports" 513# Generates Makefiles for the given list of directories.
292 fi 514prepare_directories() {
293 515 for x in "$@"; do
294 # precompiled headers doesn't work on hardened, where the flag is masked. 516 pushd "${S}"/${x} >/dev/null || die
295 if use pch; then 517 einfo "Running qmake in: ${x}"
296 myconf="${myconf} -pch" 518 "${S}"/bin/qmake \
297 else 519 "LIBS+=-L${QTLIBDIR}" \
298 myconf="${myconf} -no-pch" 520 "CONFIG+=nostrip" \
299 fi 521 || die "qmake failed"
300 522 popd >/dev/null || die
301 if use debug; then 523 done
302 myconf="${myconf} -debug -no-separate-debug-info"
303 else
304 myconf="${myconf} -release -no-separate-debug-info"
305 fi
306
307 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
308 # $(tc-arch). Therefore we convert it to supported values.
309 case "$(tc-arch)" in
310 amd64) myconf="${myconf} -arch x86_64" ;;
311 ppc|ppc64) myconf="${myconf} -arch powerpc" ;;
312 x86|x86-*) myconf="${myconf} -arch i386" ;;
313 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;;
314 hppa|sh) myconf="${myconf} -arch generic" ;;
315 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
316 esac
317
318 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
319 local exceptions=
320 case "${PV}" in
321 4.6.*)
322 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
323 exceptions="-no-exceptions"
324 fi
325 ;;
326 *)
327 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
328 ;;
329 esac
330
331 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
332 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
333 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
334 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
335 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
336 -demosdir ${QTDEMOSDIR} -silent -fast
337 ${exceptions}
338 -reduce-relocations -nomake examples -nomake demos"
339
340 # Make eclass >= 4.5.x ready
341 case "${MY_PV}" in
342 4.5.* | 4.6.* )
343 myconf="${myconf} -opensource"
344 ;;
345 esac
346
347 echo "${myconf}"
348} 524}
349 525
350# @FUNCTION: build_directories 526# @FUNCTION: build_directories
351# @USAGE: < directories > 527# @USAGE: < directories >
528# @INTERNAL
352# @DESCRIPTION: 529# @DESCRIPTION:
353# Compiles the code in $QT4_TARGET_DIRECTORIES 530# Compiles the code in the given list of directories.
354build_directories() { 531build_directories() {
355 local dirs="$@"
356 for x in ${dirs}; do 532 for x in "$@"; do
357 cd "${S}"/${x} 533 pushd "${S}"/${x} >/dev/null || die
358 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 534 emake \
359 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 535 AR="$(tc-getAR) cqs" \
360 emake CC="@echo compiling \$< && $(tc-getCC)" \ 536 CC="$(tc-getCC)" \
361 CXX="@echo compiling \$< && $(tc-getCXX)" \ 537 CXX="$(tc-getCXX)" \
362 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
541 popd >/dev/null || die
363 done 542 done
364} 543}
365 544
366# @FUNCTION: install_directories 545# @FUNCTION: install_directories
367# @USAGE: < directories > 546# @USAGE: < directories >
547# @INTERNAL
368# @DESCRIPTION: 548# @DESCRIPTION:
369# run emake install in the given directories, which are separated by spaces 549# Runs emake install in the given directories, which are separated by spaces.
370install_directories() { 550install_directories() {
371 local dirs="$@"
372 for x in ${dirs}; do 551 for x in "$@"; do
373 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 552 pushd "${S}"/${x} >/dev/null || die
374 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
375 popd >/dev/null || die "Can't popd from ${S}/${x}" 554 popd >/dev/null || die
376 done 555 done
377} 556}
378 557
379# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
380# @DESCRIPTION: 559# @DESCRIPTION:
381# List options that need to be added to QT_CONFIG in qconfig.pri 560# List options that need to be added to QT_CONFIG in qconfig.pri
382QCONFIG_ADD="${QCONFIG_ADD:-}" 561: ${QCONFIG_ADD:=}
383 562
384# @ECLASS-VARIABLE: QCONFIG_REMOVE 563# @ECLASS-VARIABLE: QCONFIG_REMOVE
385# @DESCRIPTION: 564# @DESCRIPTION:
386# List options that need to be removed from QT_CONFIG in qconfig.pri 565# List options that need to be removed from QT_CONFIG in qconfig.pri
387QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 566: ${QCONFIG_REMOVE:=}
388 567
389# @ECLASS-VARIABLE: QCONFIG_DEFINE 568# @ECLASS-VARIABLE: QCONFIG_DEFINE
390# @DESCRIPTION: 569# @DESCRIPTION:
391# List variables that should be defined at the top of QtCore/qconfig.h 570# List variables that should be defined at the top of QtCore/qconfig.h
392QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 571: ${QCONFIG_DEFINE:=}
393 572
394# @FUNCTION: install_qconfigs 573# @FUNCTION: install_qconfigs
574# @INTERNAL
575# @DESCRIPTION:
395# @DESCRIPTION: Install gentoo-specific mkspecs configurations 576# Install gentoo-specific mkspecs configurations.
396install_qconfigs() { 577install_qconfigs() {
397 local x 578 local x
398 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
399 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
400 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
401 done 582 done
402 insinto ${QTDATADIR}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
403 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
404 fi 585 fi
405 586
406 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
407 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
408 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
409 done 590 done
410 insinto ${QTHEADERDIR}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
411 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
412 fi 593 fi
413} 594}
414 595
415# @FUNCTION: generate_qconfigs 596# @FUNCTION: generate_qconfigs
416# @DESCRIPTION: Generates gentoo-specific configurations 597# @INTERNAL
598# @DESCRIPTION:
599# Generates gentoo-specific qconfig.{h,pri}.
417generate_qconfigs() { 600generate_qconfigs() {
418 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
419 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
420 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
421 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
422 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
423 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
424 done 607 done
425 608
426 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
427 # just makes things worse. 610 # just makes things worse.
428 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
429 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
430 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
431 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
432 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
433 return 1 616 return 1
434 fi 617 fi
435 618
436 # generate list of QT_CONFIG entries from the existing list 619 # generate list of QT_CONFIG entries from the existing list
437 # including qconfig_add and excluding qconfig_remove 620 # including qconfig_add and excluding qconfig_remove
438 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 621 for x in $(sed -n 's/^QT_CONFIG +=//p' \
439 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 622 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
440 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 623 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
441 done 624 done
442 625
443 # replace the existing QT_CONFIG list with qconfig_new 626 # replace the existing QT_CONFIG list with qconfig_new
444 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 627 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
445 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 628 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
469 fi 652 fi
470 fi 653 fi
471} 654}
472 655
473# @FUNCTION: qt4-build_pkg_postrm 656# @FUNCTION: qt4-build_pkg_postrm
657# @DESCRIPTION:
474# @DESCRIPTION: Generate configurations when the package is completely removed 658# Regenerate configuration when the package is completely removed.
475qt4-build_pkg_postrm() { 659qt4-build_pkg_postrm() {
476 generate_qconfigs 660 generate_qconfigs
477} 661}
478 662
479# @FUNCTION: qt4-build_pkg_postinst 663# @FUNCTION: qt4-build_pkg_postinst
664# @DESCRIPTION:
480# @DESCRIPTION: Generate configuration, plus throws a message about possible 665# Regenerate configuration, plus throw a message about possible
481# breakages and proposed solutions. 666# breakages and proposed solutions.
482qt4-build_pkg_postinst() { 667qt4-build_pkg_postinst() {
483 generate_qconfigs 668 generate_qconfigs
484 echo
485 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
486 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
487 ewarn "should recompile the packages providing these plugins. Also, make sure you"
488 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
489 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
490 ewarn
491 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
492 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
493 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
494 ewarn "configuration."
495 ewarn
496 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
497 echo
498} 669}
499 670
500# @FUNCTION: skip_qmake_build_patch 671# @FUNCTION: skip_qmake_build
672# @INTERNAL
501# @DESCRIPTION: 673# @DESCRIPTION:
502# Don't need to build qmake, as it's already installed from qt-core 674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
503skip_qmake_build_patch() { 675skip_qmake_build() {
504 # Don't need to build qmake, as it's already installed from qt-core
505 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
506} 677}
507 678
508# @FUNCTION: skip_project_generation_patch 679# @FUNCTION: skip_project_generation
680# @INTERNAL
509# @DESCRIPTION: 681# @DESCRIPTION:
510# Exit the script early by throwing in an exit before all of the .pro files are scanned 682# Exit the script early by throwing in an exit before all of the .pro files are scanned.
511skip_project_generation_patch() { 683skip_project_generation() {
512 # Exit the script early by throwing in an exit before all of the .pro files are scanned
513 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 684 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
514 -i "${S}"/configure || die "Sed failed"
515} 685}
516 686
517# @FUNCTION: symlink_binaries_to_buildtree 687# @FUNCTION: symlink_binaries_to_buildtree
688# @INTERNAL
518# @DESCRIPTION: 689# @DESCRIPTION:
519# Symlink generated binaries to buildtree so they can be used during compilation 690# Symlinks generated binaries to buildtree, so they can be used during compilation time.
520# time
521symlink_binaries_to_buildtree() { 691symlink_binaries_to_buildtree() {
522 for bin in qmake moc uic rcc; do 692 for bin in qmake moc uic rcc; do
523 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 693 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
524 done 694 done
525} 695}
526 696
527# @FUNCTION: fix_library_files 697# @FUNCTION: fix_library_files
698# @INTERNAL
528# @DESCRIPTION: 699# @DESCRIPTION:
529# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 700# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
530# moves the *.pc-files into the pkgconfig directory 701# moves the *.pc files into the pkgconfig directory.
531fix_library_files() { 702fix_library_files() {
703 local libfile
532 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
533 if [[ -e ${libfile} ]]; then 705 if [[ -e ${libfile} ]]; then
534 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
535 fi 707 fi
536 done 708 done
537 709
538 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
539 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
540 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
541 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
542 714
543 # Move .pc files into the pkgconfig directory 715 # Move .pc files into the pkgconfig directory
544 dodir ${QTPCDIR} 716 dodir ${QTPCDIR#${EPREFIX}}
545 mv ${libfile} "${D}"/${QTPCDIR}/ \ 717 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
546 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
547 fi 718 fi
548 done 719 done
549 720
550 # Don't install an empty directory 721 # Don't install an empty directory
551 rmdir "${D}"/${QTLIBDIR}/pkgconfig 722 rmdir "${D}"/${QTLIBDIR}/pkgconfig
552} 723}
553 724
554# @FUNCTION: qt_use 725# @FUNCTION: qt_use
555# @USAGE: < flag > [ feature ] [ enableval ] 726# @USAGE: < flag > [ feature ] [ enableval ]
556# @DESCRIPTION: 727# @DESCRIPTION:
557# This will echo "${enableval}-${feature}" if <flag> is enabled, or 728# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
558# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 729# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
559# will be used for that. If [enableval] is not specified, it omits the 730# will be used for that. If [enableval] is not specified, it omits the
560# assignment-part 731# "-${enableval}" part.
561qt_use() { 732qt_use() {
562 local flag="${1}" 733 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
563 local feature="${1}"
564 local enableval=
565
566 [[ -n ${2} ]] && feature=${2}
567 [[ -n ${3} ]] && enableval="-${3}"
568
569 if use ${flag}; then
570 echo "${enableval}-${feature}"
571 else
572 echo "-no-${feature}"
573 fi
574}
575
576# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
577# @DESCRIPTION:
578# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
579# (eutils.eclass), line per line.
580#
581# Example:
582# @CODE
583# pkg_setup() {
584# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
585# ~x11-libs/qt-gui-${PV} qt3support"
586# qt4-build_check_use
587# }
588# @CODE
589
590# Run built_with_use on each flag and print appropriate error messages if any
591# flags are missing
592
593_qt_built_with_use() {
594 local missing opt pkg flag flags
595
596 if [[ ${1} = "--missing" ]]; then
597 missing="${1} ${2}" && shift 2
598 fi
599 if [[ ${1:0:1} = "-" ]]; then
600 opt=${1} && shift
601 fi
602
603 pkg=${1} && shift
604
605 for flag in "${@}"; do
606 flags="${flags} ${flag}"
607 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
608 flags="${flags}*"
609 else
610 [[ ${opt} = "-o" ]] && return 0
611 fi
612 done
613 if [[ "${flags# }" = "${@}" ]]; then
614 return 0
615 fi
616 if [[ ${opt} = "-o" ]]; then
617 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
618 else
619 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
620 fi
621 return 1
622}
623
624# @FUNCTION: qt4-build_check_use
625# @DESCRIPTION:
626# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
627# USE flags listed.
628#
629# If any of the required USE flags are missing, an eerror will be printed for
630# each package with missing USE flags.
631qt4-build_check_use() {
632 local line missing
633 while read line; do
634 [[ -z ${line} ]] && continue
635 if ! _qt_built_with_use ${line}; then
636 missing=true
637 fi
638 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
639 if [[ -n ${missing} ]]; then
640 echo
641 eerror "Flags marked with an * are missing."
642 die "Missing USE flags found"
643 fi
644} 734}
645 735
646# @FUNCTION: qt_mkspecs_dir 736# @FUNCTION: qt_mkspecs_dir
647# @RETURN: the specs-directory w/o path 737# @RETURN: the specs-directory w/o path
648# @DESCRIPTION: 738# @DESCRIPTION:
649# Allows us to define which mkspecs dir we want to use. 739# Allows us to define which mkspecs dir we want to use.
650qt_mkspecs_dir() { 740qt_mkspecs_dir() {
651 # Allows us to define which mkspecs dir we want to use.
652 local spec 741 local spec=
653 742
654 case ${CHOST} in 743 case "${CHOST}" in
655 *-freebsd*|*-dragonfly*) 744 *-freebsd*|*-dragonfly*)
656 spec="freebsd" ;; 745 spec=freebsd ;;
657 *-openbsd*) 746 *-openbsd*)
658 spec="openbsd" ;; 747 spec=openbsd ;;
659 *-netbsd*) 748 *-netbsd*)
660 spec="netbsd" ;; 749 spec=netbsd ;;
661 *-darwin*) 750 *-darwin*)
751 if use aqua; then
752 # mac with carbon/cocoa
753 spec=macx
754 else
755 # darwin/mac with x11
662 spec="darwin" ;; 756 spec=darwin
757 fi
758 ;;
759 *-solaris*)
760 spec=solaris ;;
663 *-linux-*|*-linux) 761 *-linux-*|*-linux)
664 spec="linux" ;; 762 spec=linux ;;
665 *) 763 *)
666 die "Unknown CHOST, no platform choosen." 764 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
667 esac 765 esac
668 766
669 CXX=$(tc-getCXX) 767 case "$(tc-getCXX)" in
670 if [[ ${CXX/g++/} != ${CXX} ]]; then 768 *g++*)
671 spec="${spec}-g++" 769 spec+=-g++ ;;
672 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 770 *icpc*)
673 spec="${spec}-icc" 771 spec+=-icc ;;
674 else 772 *)
675 die "Unknown compiler ${CXX}." 773 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
676 fi 774 esac
677 if [[ -n "${LIBDIR/lib}" ]]; then 775
678 spec="${spec}-${LIBDIR/lib}" 776 # Add -64 for 64bit profiles
777 if use x64-freebsd ||
778 use amd64-linux ||
779 use x64-macos ||
780 use x64-solaris ||
781 use sparc64-solaris
782 then
783 spec+=-64
679 fi 784 fi
680 785
681 echo "${spec}" 786 echo "${spec}"
682} 787}
683 788
684case ${EAPI:-0} in 789# @FUNCTION: qt_nolibx11
685 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 790# @INTERNAL
791# @DESCRIPTION:
792# Skip X11 tests for packages that don't need X libraries installed.
793qt_nolibx11() {
794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
795}
796
686 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
687esac

Legend:
Removed from v.1.50  
changed lines
  Added in v.1.159

  ViewVC Help
Powered by ViewVC 1.1.20